package Client;

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.Timer;

import Logic.BaseShape;
import Logic.MainLogic;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class MainClient {

	private JFrame frame;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					MainClient window = new MainClient();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	StarField mMainField;
	MainLogic mLogic;
	Timer mMainTimer;
	
	public MainClient() {
		initialize();
		mLogic = new MainLogic();
		mLogic.SetSize( mMainField.getWidth(), mMainField.getHeight() );

		Point tCenter = new Point(mMainField.getWidth() / 2, mMainField.getHeight() / 2);
	    BaseShape tNewShape = mLogic.CreateObject(tCenter, tCenter);
	    mMainField.CreateSpriteForShape(tNewShape, Color.RED);
	    
	    mMainTimer = new Timer( 1000/60, new ActionListener()
	    		{
					public void actionPerformed(ActionEvent arg0) 
					{
						// Shortcutting the concept of Interpolation, where the client and logic have their own timers, because man that's hard.
						mLogic.Update(1/60.0f);
						mMainField.repaint();
					}
	    		});
	    mMainTimer.start();
	}
	
	

	/**
	 * Initialize the contents of the frame.
	 */
	Point mClickDown = new Point();
	Color mNextColor = Color.BLACK;
	private void initialize() {
		frame = new JFrame();
		frame.setBounds(100, 100, 600, 450);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);
		
		mMainField = new StarField();
		mMainField.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) 
			{
				int x = e.getX();
			    int y = e.getY();
				mClickDown.setLocation(x, y);
			}
			@Override
			public void mouseReleased(MouseEvent e) 
			{
				int x = e.getX();
			    int y = e.getY();
			    Point tClickUp = new Point(x, y);
			    BaseShape tNewShape = mLogic.CreateObject(mClickDown, tClickUp);
			    mMainField.CreateSpriteForShape(tNewShape, mNextColor);
			}
		});
		mMainField.setBackground(Color.WHITE);
		mMainField.setBounds(10, 11, 425, 389);
		frame.getContentPane().add(mMainField);
		
		JButton mColorButton1 = new JButton("Blue");
		mColorButton1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				mNextColor = Color.BLUE;
			}
		});
		mColorButton1.setBounds(445, 11, 89, 23);
		frame.getContentPane().add(mColorButton1);
		
		JButton mColorButton2 = new JButton("Red");
		mColorButton2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				mNextColor = Color.RED;
			}
		});
		mColorButton2.setBounds(445, 45, 89, 23);
		frame.getContentPane().add(mColorButton2);
		
		JButton mColorButton3 = new JButton("Green");
		mColorButton3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				mNextColor = Color.GREEN;
			}
		});
		mColorButton3.setBounds(445, 79, 89, 23);
		frame.getContentPane().add(mColorButton3);
		
		JButton mColorButton4 = new JButton("Black");
		mColorButton4.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				mNextColor = Color.BLACK;
			}
		});
		mColorButton4.setBounds(445, 113, 89, 23);
		frame.getContentPane().add(mColorButton4);
	}
}
